<!doctype html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>GitLab Flavored Markdown dingus</title>

<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-QWTKZyjpPEjISv5WaRU9OFeRpok6YctnYmDr5pNlyT2bRjXh0JMhjY6hW+ALEwIH" crossorigin="anonymous">
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-YvpcrYf0tY3lHB60NNkmXc5s9fDVZLESaAA55NDzOxhy9GkcIdslK1eN7N6jIeHz" crossorigin="anonymous"></script>

  <link href="stylesheets/dingus.css" rel="stylesheet">

  <script type="module">
    import { load } from './javascripts/dingus.js';

    load();
  </script>
</head>
<body>
<div class="container">
  <div class="row">
    <div class="col">
      <h1 class="title">CommonMark/GFM/GLFM dingus <small><small>powered by <a href="https://github.com/kivikakk/comrak">comrak 0.36.0</a></small></small></h1>
    </div>
  </div>

  <div class="row">
    <div class="col-md-12">
      <div class="btn-toolbar mb-2" role="toolbar">
        <div class="btn-group btn-group-sm">
          <button type="button" id="clear-text-box" class="btn btn-outline-primary">clear</button>
          <button type="button" id="permalink" class="btn btn-outline-primary">permalink</button>
          <button class="btn btn-outline-primary" type="button" data-bs-toggle="collapse" data-bs-target="#collapseOptions" aria-expanded="false" aria-controls="collapseOptions">
            options
          </button>
        </div>
      </div>
      <div class="collapse" id="collapseOptions">
        <div class="card mb-2">
          <div class="card-header">
            Extension options
          </div>
          <div class="card-body">
            <div class="row mt-0">
              <div class="col-auto">
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="alerts">
                  <input type="checkbox" class="btn-check" id="alerts" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="alerts"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables the alerts extension, for GitHub style alerts">
                    alerts
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="autolink">
                  <input type="checkbox" class="btn-check" id="autolink" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="autolink"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables the autolink extension from the GFM spec">
                    autolink
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="description lists">
                  <input type="checkbox" class="btn-check" id="description_lists" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="description_lists"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables the description lists extension">
                    description_lists
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="footnotes">
                  <input type="checkbox" class="btn-check" id="footnotes" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="footnotes"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables the footnotes extension per `cmark-gfm`">
                    footnotes
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="front matter delimter">
                  <input type="checkbox" class="btn-check" id="front_matter_delimiter" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="front_matter_delimiter"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Detect front matter (set to `---`)">
                    front_matter_delimiter
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="emojis">
                  <input type="checkbox" class="btn-check" id="gemojis" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="gemojis"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Translate gemojis into UTF-8 characters">
                    gemojis
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="green text">
                  <input type="checkbox" class="btn-check" id="greentext" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="greentext"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Requires at least one space after a `>` character to generate a blockquote, and restarts blockquote nesting across unique lines of input">
                    greentext
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="header ids">
                  <input type="checkbox" class="btn-check" id="header_ids" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="header_ids"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Use the Comrak header IDs extension, with 'user-content-'">
                    header_ids
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="math">
                  <input type="checkbox" class="btn-check" id="math_code" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="math_code"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables math code extension, using math code syntax">
                    math_code
                  </label>

                  <input type="checkbox" class="btn-check" id="math_dollars" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="math_dollars"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables math dollar extension, using math dollar syntax">
                    math_dollars
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="multiline block quotes">
                  <input type="checkbox" class="btn-check" id="multiline_block_quotes" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="multiline_block_quotes"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables the multiline block quote extension">
                    multiline_block_quotes
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="spoiler">
                  <input type="checkbox" class="btn-check" id="spoiler" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="spoiler"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables spoilers using double vertical bars">
                    spoiler
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="strikethrough">
                  <input type="checkbox" class="btn-check" id="strikethrough" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="strikethrough"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables the strikethrough Comrak extension">
                    strikethrough
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="subscript">
                  <input type="checkbox" class="btn-check" id="subscript" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="subscript"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables the subscript Comrak extension">
                    subscript
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="superscript">
                  <input type="checkbox" class="btn-check" id="superscript" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="superscript"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables the superscript Comrak extension">
                    superscript
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="table">
                  <input type="checkbox" class="btn-check" id="table" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="table"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables the table extension from the GFM spec">
                    table
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="tag filter">
                  <input type="checkbox" class="btn-check" id="tagfilter" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="tagfilter"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables the tagfilter extension from the GFM spec">
                    tagfilter
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="tasklist">
                  <input type="checkbox" class="btn-check" id="tasklist" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="tasklist"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables the tasklist extension from the GFM spec">
                    tasklist
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="underline">
                  <input type="checkbox" class="btn-check" id="underline" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="underline"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables underlines using double underscores">
                    underline
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="wikilinks">
                  <input type="checkbox" class="btn-check" id="wikilinks_title_after_pipe" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="wikilinks_title_after_pipe"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables wikilinks extension, using title after pipe syntax">
                    wikilinks_title_after_pipe
                  </label>

                  <input type="checkbox" class="btn-check" id="wikilinks_title_before_pipe" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="wikilinks_title_before_pipe"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables wikilinks extension, using title before pipe syntax">
                    wikilinks_title_before_pipe
                  </label>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="card mb-2">
          <div class="card-header">
            Render options
          </div>
          <div class="card-body">
            <div class="row mt-0">
              <div class="col-auto">
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="escape">
                  <input type="checkbox" class="btn-check" id="escape" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="escape"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Escape raw HTML instead of clobbering it">
                    escape
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="escaped character spans">
                  <input type="checkbox" class="btn-check" id="escaped_char_spans" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="escaped_char_spans"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Wrap escaped characters in span tags">
                    escaped_char_spans
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="figure with caption">
                  <input type="checkbox" class="btn-check" id="figure_with_caption" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="figure_with_caption"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Render the image as a figure element with the title as its caption">
                    figure_with_caption
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="full info string">
                  <input type="checkbox" class="btn-check" id="full_info_string" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="full_info_string"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enable full info strings for code blocks">
                    full_info_string
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="gfm quirks">
                  <input type="checkbox" class="btn-check" id="gfm_quirks" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="gfm_quirks"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enables GFM quirks in HTML output which break CommonMark compatibility">
                    gfm_quirks
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="github pre lang">
                  <input type="checkbox" class="btn-check" id="github_pre_lang" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="github_pre_lang"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Use GitHub-style <pre lang> for code blocks">
                    github_pre_lang
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="hardbreaks">
                  <input type="checkbox" class="btn-check" id="hardbreaks" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="hardbreaks"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Treat newlines as hard line breaks">
                    hardbreaks
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="ignore empty links">
                  <input type="checkbox" class="btn-check" id="ignore_empty_links" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="ignore_empty_links"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Ignore empty links in input">
                    ignore_empty_links
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="ignore setext">
                  <input type="checkbox" class="btn-check" id="ignore_setext" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="ignore_setext"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Ignore setext headings in input">
                    ignore_setext
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="sourcepos">
                  <input type="checkbox" class="btn-check" id="sourcepos" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="sourcepos"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Include source position attribute in HTML and XML output">
                    sourcepos
                  </label>

                  <input type="checkbox" class="btn-check" id="experimental_inline_sourcepos" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="experimental_inline_sourcepos"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Include inline sourcepos in HTML output, which is known to have issues">
                    inline_sourcepos
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="unsafe">
                  <input type="checkbox" class="btn-check" id="unsafe_" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="unsafe_"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Allow raw HTML and dangerous URLs">
                    unsafe
                  </label>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="card mb-2">
          <div class="card-header">
            Parse options
          </div>
          <div class="card-body">
            <div class="row mt-0">
              <div class="col-auto">
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="default info string">
                  <input type="checkbox" class="btn-check" id="default_info_string" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="default_info_string"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="The default info string for fenced code blocks (set to `ruby`)">
                    default_info_string
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="relaxed autolinks">
                  <input type="checkbox" class="btn-check" id="relaxed_autolinks" autocomplete="off" checked>
                  <label class="btn btn-outline-secondary" for="relaxed_autolinks"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Enable relaxing of autolink parsing, allowing links to be recognized when in brackets and
                    allow all url schemes">
                    relaxed_autolinks
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="relaxed tasklist character">
                  <input type="checkbox" class="btn-check" id="relaxed_tasklist_character" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="relaxed_tasklist_character"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Whether or not a simple `x` or `X` is used for tasklist or any other symbol is allowed">
                    relaxed_tasklist_character
                  </label>
                </div>
                <div class="btn-group btn-group-sm mb-1" role="group" aria-label="smart">
                  <input type="checkbox" class="btn-check" id="smart" autocomplete="off">
                  <label class="btn btn-outline-secondary" for="smart"
                    data-bs-toggle="tooltip" data-bs-placement="top" data-bs-delay="500"
                    data-bs-title="Punctuation (quotes, full-stops and hyphens) are converted into 'smart' punctuation">
                    smart
                  </label>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="row">
    <div class="col-md-6 mb-3">
      <ul id="markdown-tabs" class="nav nav-tabs" role="tablist">
        <li class="nav-item" role="presentation">
          <a href="#markdown-pane" class="nav-link active" role="tab" data-bs-toggle="tab" data-bs-target="#markdown-pane">Markdown</a>
        </li>
      </ul>
      <!-- <div class="tab-content border-start border-end border-bottom rounded-bottom-1" id="markdown-tabs-content"> -->
      <div class="tab-content" id="markdown-tabs-content">
        <div id="markdown-pane" class="tab-pane fade show active tabbed_content">
          <textarea class="form-control monospaced " id="markdown">---
front matter that is stripped when `front_matter_delimiter` enabled
---

## Try CommonMark/GFM/GLFM

![](images/markdown-logo-66x40.png "Markdown mark from https://github.com/dcurtis/markdown-mark")

You can try CommonMark with GitHub[^gfm] and GitLab Flavored Markdown[^glfm].
This dingus is powered by
[comrak](https://github.com/kivikakk/comrak)[^comrak]

### Option examples

- **autolinks:** www.commonmark.org
- **escape**: Raw HTML <strong>escaped</strong>
- **escaped_char_spans**: \@user
- **footnotes**: [comrak](https://github.com/kivikakk/comrak)[^1]
- **gemojis**: :smile: :thumbsup:
- **gfm_quirks**: ****extra `strong` tags removed****
- **ignore_empty_links**: []()
- **math_code**: Inline math $`x^2`$
- **math_dollars**: Inline math $x^2$ and display $$y^2$$
- **relaxed autolinks**: [http://example.com]
- **smart**: Using "smart quotes"
- **spoiler**: Darth Vader is ||Luke's father||
- **strikethrough**: ~~text stricken through~~
- **subscript**: x~2~
- **superscript**: x^2^
- **tasklist**:
  - [ ] task 1
  - [x] task 2
  - [-] relaxed tasklist character
- **underline**: __underlined text__
- **wikilinks_title_after_pipe**: [[link|title]]
- **wikilinks_title_before_pipe**: [[title|link]]

```markdown extra info
A code block with full_info_string and
github_pre_lang shown in HTML
```

| Table      | Example |
| ---------- | -------:|
| Completion | 65%     |

>>>
A **multiline block quote** can easily
quote multiple lines.
>>>

`math_code ` inline and block math: $`x = 1`$

```math
x + y = z
```

`math_dollars` inline and block math: $x = 1$

$$
x + y
$$

```
Language should be `ruby` when `default_info_string` enabled
```

Description List Term

: Definition 1
: Definition 2

GitHub style alerts

> [!note]
> Highlights information that users should take into account, even when skimming.

> [!tip]
> Optional information to help a user be more successful.

> [!important]
> Crucial information necessary for users to succeed.

> [!warning]
> Critical content demanding immediate user attention due to potential risks.

> [!caution]
> Negative potential consequences of an action.

> [!note] Interesting fact
> The title can be overridden

>>> [!note] GitLab multiline alerts
Easy mulitline alerts are supported by using the GitLab multine blockquote syntax
>>>

>Greentext blockquote requires a space after `>`

> Greentext restarts blockquote nesting across unique lines of input
> > two
> three

Ignore Setext headers
---------------------
Use the `ignore_setext` to turn off parsing of setext headers

------

[^comrak]: [comrak](https://github.com/kivikakk/comrak) is an implementation
of CommonMark with GFM, built in Rust.
[^gfm]: [GitHub Flavored Markdown](https://github.github.com/gfm)
[^glfm]: [GitLab Flavored Markdown](https://docs.gitlab.com/ee/user/markdown.html)
          </textarea>
        </div>
      </div>
    </div>

    <div class="col-md-6 mb-3">
      <ul id="result-tabs" class="nav nav-tabs" role="tablist">
        <li class="nav-item" role="presentation">
          <a href="#preview_iframe" class="nav-link active" role="tab" data-bs-toggle="tab" data-bs-target="#preview_iframe">Preview</a>
        </li>
        <li class="nav-item" role="presentation">
          <a href="#result" class="nav-link" role="tab" data-bs-toggle="tab" data-bs-target="#result">HTML</a>
        </li>
        <li class="nav-item" role="presentation">
          <a href="#result-ast" class="nav-link" role="tab" data-bs-toggle="tab" data-bs-target="#result-ast">AST</a>
        </li>
      </ul>
      <div class="tab-content border-start border-end border-bottom rounded-bottom-1" id="result-tabs-content">
        <iframe id="preview_iframe" class="tab-pane fade show active tabbed_content" src="preview.html" frameborder="0" sandbox="allow-same-origin"></iframe>
        <!-- <div id="preview" class="tab-pane fade show active">
          <iframe id="iframe" src="preview.html" frameborder="0" sandbox="allow-same-origin"></iframe>
        </div> -->
        <div id="result" class="tab-pane fade show">
          <pre id="htmlpre" class="monospaced tabbed_content"><code id="html"></code></pre>
        </div>
        <div id="result-ast" class="tab-pane fade show">
          <pre id="astpre" class="monospaced tabbed_content"><code id="ast"></code></pre>
        </div>
      </div>
    </div>
  </div>
</div>
</body>
</html>
